#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf sparc-utils_1.9.orig.tar.gz
    cd sparc-utils-1.9.orig
    gunzip -c ../sparc-utils_1.9-4.diff.gz | patch -p1 -b
    cd prtconf-1.3
    make CFLAGS="$CFLAGS"
    strip -R .note -R .comment eeprom prtconf
    mkdir -p ../../eeprom/sbin ../../prtconf/sbin
    cp eeprom ../../eeprom/sbin/
    cp prtconf ../../prtconf/sbin/
    cd ../..
    rm -rf sparc-utils-1.9.orig
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
